/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AboutUsPageModel } from '../models';
import { AboutUsPagesModel } from '../models';
import { CreateAboutUsPageCommand } from '../models';
import { TranslateAboutUsPageCommand } from '../models';
import { UpdateAboutUsPageCommand } from '../models';
/**
 * AboutUsApi - axios parameter creator
 * @export
 */
export declare const AboutUsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all AboutUsList.
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [name]
     * @param {boolean} [returnDefaultValue]
     * @param {boolean} [confirmed]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusGet: (hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete AboutUs.
     * @param {string} hospitalId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdDelete: (hospitalId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get AboutUs.
     * @param {string} hospitalId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdGet: (hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update AboutUs.
     * @param {string} hospitalId
     * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdPut: (hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate aboutUsPage
     * @param {string} hospitalId
     * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdTranslatePost: (hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create AboutUs.
     * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusPost: (createAboutUsPageCommand?: CreateAboutUsPageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * AboutUsApi - functional programming interface
 * @export
 */
export declare const AboutUsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all AboutUsList.
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [name]
     * @param {boolean} [returnDefaultValue]
     * @param {boolean} [confirmed]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusGet(hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPagesModel>>;
    /**
     *
     * @summary Delete AboutUs.
     * @param {string} hospitalId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdDelete(hospitalId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get AboutUs.
     * @param {string} hospitalId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdGet(hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>>;
    /**
     *
     * @summary Update AboutUs.
     * @param {string} hospitalId
     * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdPut(hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>>;
    /**
     *
     * @summary Translate aboutUsPage
     * @param {string} hospitalId
     * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdTranslatePost(hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create AboutUs.
     * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusPost(createAboutUsPageCommand?: CreateAboutUsPageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AboutUsPageModel>>;
};
/**
 * AboutUsApi - factory interface
 * @export
 */
export declare const AboutUsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all AboutUsList.
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [hospitalSlug]
     * @param {string} [name]
     * @param {boolean} [returnDefaultValue]
     * @param {boolean} [confirmed]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusGet(hospitalId?: string, hospitalName?: string, hospitalSlug?: string, name?: string, returnDefaultValue?: boolean, confirmed?: boolean, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AboutUsPagesModel>;
    /**
     *
     * @summary Delete AboutUs.
     * @param {string} hospitalId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdDelete(hospitalId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get AboutUs.
     * @param {string} hospitalId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdGet(hospitalId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<AboutUsPageModel>;
    /**
     *
     * @summary Update AboutUs.
     * @param {string} hospitalId
     * @param {UpdateAboutUsPageCommand} [updateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdPut(hospitalId: string, updateAboutUsPageCommand?: UpdateAboutUsPageCommand, options?: any): AxiosPromise<AboutUsPageModel>;
    /**
     *
     * @summary Translate aboutUsPage
     * @param {string} hospitalId
     * @param {TranslateAboutUsPageCommand} [translateAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusHospitalIdTranslatePost(hospitalId: string, translateAboutUsPageCommand?: TranslateAboutUsPageCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create AboutUs.
     * @param {CreateAboutUsPageCommand} [createAboutUsPageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusPost(createAboutUsPageCommand?: CreateAboutUsPageCommand, options?: any): AxiosPromise<AboutUsPageModel>;
    /**
     *
     * @summary
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1AboutusSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<AboutUsPageModel>;
};
/**
 * Request parameters for apiV1AboutusGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusGetRequest
 */
export interface AboutUsApiApiV1AboutusGetRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly hospitalSlug?: string;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly name?: string;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly confirmed?: boolean;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof AboutUsApiApiV1AboutusGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1AboutusHospitalIdDelete operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdDeleteRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdDelete
     */
    readonly hospitalId: string;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusHospitalIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1AboutusHospitalIdGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdGetRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly hospitalId: string;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusHospitalIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1AboutusHospitalIdPut operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdPutRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdPut
     */
    readonly hospitalId: string;
    /**
     *
     * @type {UpdateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusHospitalIdPut
     */
    readonly updateAboutUsPageCommand?: UpdateAboutUsPageCommand;
}
/**
 * Request parameters for apiV1AboutusHospitalIdTranslatePost operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest
 */
export interface AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusHospitalIdTranslatePost
     */
    readonly hospitalId: string;
    /**
     *
     * @type {TranslateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusHospitalIdTranslatePost
     */
    readonly translateAboutUsPageCommand?: TranslateAboutUsPageCommand;
}
/**
 * Request parameters for apiV1AboutusPost operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusPostRequest
 */
export interface AboutUsApiApiV1AboutusPostRequest {
    /**
     *
     * @type {CreateAboutUsPageCommand}
     * @memberof AboutUsApiApiV1AboutusPost
     */
    readonly createAboutUsPageCommand?: CreateAboutUsPageCommand;
}
/**
 * Request parameters for apiV1AboutusSlugGet operation in AboutUsApi.
 * @export
 * @interface AboutUsApiApiV1AboutusSlugGetRequest
 */
export interface AboutUsApiApiV1AboutusSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof AboutUsApiApiV1AboutusSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * AboutUsApi - object-oriented interface
 * @export
 * @class AboutUsApi
 * @extends {BaseAPI}
 */
export declare class AboutUsApi extends BaseAPI {
    /**
     *
     * @summary Get all AboutUsList.
     * @param {AboutUsApiApiV1AboutusGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusGet(requestParameters?: AboutUsApiApiV1AboutusGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AboutUsPagesModel, any>>;
    /**
     *
     * @summary Delete AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusHospitalIdDelete(requestParameters: AboutUsApiApiV1AboutusHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusHospitalIdGet(requestParameters: AboutUsApiApiV1AboutusHospitalIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AboutUsPageModel, any>>;
    /**
     *
     * @summary Update AboutUs.
     * @param {AboutUsApiApiV1AboutusHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusHospitalIdPut(requestParameters: AboutUsApiApiV1AboutusHospitalIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AboutUsPageModel, any>>;
    /**
     *
     * @summary Translate aboutUsPage
     * @param {AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusHospitalIdTranslatePost(requestParameters: AboutUsApiApiV1AboutusHospitalIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create AboutUs.
     * @param {AboutUsApiApiV1AboutusPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusPost(requestParameters?: AboutUsApiApiV1AboutusPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AboutUsPageModel, any>>;
    /**
     *
     * @summary
     * @param {AboutUsApiApiV1AboutusSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AboutUsApi
     */
    apiV1AboutusSlugGet(requestParameters: AboutUsApiApiV1AboutusSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AboutUsPageModel, any>>;
}
//# sourceMappingURL=about-us-api.d.ts.map