/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AccreditationModel } from '../models';
// @ts-ignore
import { AccreditationsModel } from '../models';
// @ts-ignore
import { CreateAccreditationCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateAccreditationCommand } from '../models';
/**
 * AccreditationsApi - axios parameter creator
 * @export
 */
export const AccreditationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdDelete: async (accreditationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'accreditationId' is not null or undefined
            assertParamExists('apiV1AccreditationsAccreditationIdDelete', 'accreditationId', accreditationId)
            const localVarPath = `/api/v1/accreditations/{accreditationId}`
                .replace(`{${"accreditationId"}}`, encodeURIComponent(String(accreditationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdGet: async (accreditationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'accreditationId' is not null or undefined
            assertParamExists('apiV1AccreditationsAccreditationIdGet', 'accreditationId', accreditationId)
            const localVarPath = `/api/v1/accreditations/{accreditationId}`
                .replace(`{${"accreditationId"}}`, encodeURIComponent(String(accreditationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Accreditation.
         * @param {string} accreditationId 
         * @param {UpdateAccreditationCommand} [updateAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdPut: async (accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'accreditationId' is not null or undefined
            assertParamExists('apiV1AccreditationsAccreditationIdPut', 'accreditationId', accreditationId)
            const localVarPath = `/api/v1/accreditations/{accreditationId}`
                .replace(`{${"accreditationId"}}`, encodeURIComponent(String(accreditationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateAccreditationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Accreditations.
         * @param {string} [name] 
         * @param {string} [logo] 
         * @param {string} [country] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsGet: async (name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/accreditations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (logo !== undefined) {
                localVarQueryParameter['Logo'] = logo;
            }

            if (country !== undefined) {
                localVarQueryParameter['Country'] = country;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Accreditation.
         * @param {CreateAccreditationCommand} [createAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsPost: async (createAccreditationCommand?: CreateAccreditationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/accreditations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createAccreditationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AccreditationsApi - functional programming interface
 * @export
 */
export const AccreditationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AccreditationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AccreditationsAccreditationIdDelete(accreditationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AccreditationsAccreditationIdDelete(accreditationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AccreditationsAccreditationIdGet(accreditationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AccreditationsAccreditationIdGet(accreditationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Accreditation.
         * @param {string} accreditationId 
         * @param {UpdateAccreditationCommand} [updateAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AccreditationsAccreditationIdPut(accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AccreditationsAccreditationIdPut(accreditationId, updateAccreditationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Accreditations.
         * @param {string} [name] 
         * @param {string} [logo] 
         * @param {string} [country] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AccreditationsGet(name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AccreditationsGet(name, logo, country, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Accreditation.
         * @param {CreateAccreditationCommand} [createAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AccreditationsPost(createAccreditationCommand?: CreateAccreditationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AccreditationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AccreditationsPost(createAccreditationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AccreditationsApi - factory interface
 * @export
 */
export const AccreditationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AccreditationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdDelete(accreditationId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1AccreditationsAccreditationIdDelete(accreditationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Accreditation.
         * @param {string} accreditationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdGet(accreditationId: string, options?: any): AxiosPromise<AccreditationModel> {
            return localVarFp.apiV1AccreditationsAccreditationIdGet(accreditationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Accreditation.
         * @param {string} accreditationId 
         * @param {UpdateAccreditationCommand} [updateAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsAccreditationIdPut(accreditationId: string, updateAccreditationCommand?: UpdateAccreditationCommand, options?: any): AxiosPromise<AccreditationModel> {
            return localVarFp.apiV1AccreditationsAccreditationIdPut(accreditationId, updateAccreditationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Accreditations.
         * @param {string} [name] 
         * @param {string} [logo] 
         * @param {string} [country] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsGet(name?: string, logo?: string, country?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AccreditationsModel> {
            return localVarFp.apiV1AccreditationsGet(name, logo, country, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Accreditation.
         * @param {CreateAccreditationCommand} [createAccreditationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AccreditationsPost(createAccreditationCommand?: CreateAccreditationCommand, options?: any): AxiosPromise<AccreditationModel> {
            return localVarFp.apiV1AccreditationsPost(createAccreditationCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1AccreditationsAccreditationIdDelete operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdDelete
     */
    readonly accreditationId: string
}

/**
 * Request parameters for apiV1AccreditationsAccreditationIdGet operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdGet
     */
    readonly accreditationId: string
}

/**
 * Request parameters for apiV1AccreditationsAccreditationIdPut operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest
 */
export interface AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdPut
     */
    readonly accreditationId: string

    /**
     * 
     * @type {UpdateAccreditationCommand}
     * @memberof AccreditationsApiApiV1AccreditationsAccreditationIdPut
     */
    readonly updateAccreditationCommand?: UpdateAccreditationCommand
}

/**
 * Request parameters for apiV1AccreditationsGet operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsGetRequest
 */
export interface AccreditationsApiApiV1AccreditationsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly logo?: string

    /**
     * 
     * @type {string}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly country?: string

    /**
     * 
     * @type {number}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof AccreditationsApiApiV1AccreditationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1AccreditationsPost operation in AccreditationsApi.
 * @export
 * @interface AccreditationsApiApiV1AccreditationsPostRequest
 */
export interface AccreditationsApiApiV1AccreditationsPostRequest {
    /**
     * 
     * @type {CreateAccreditationCommand}
     * @memberof AccreditationsApiApiV1AccreditationsPost
     */
    readonly createAccreditationCommand?: CreateAccreditationCommand
}

/**
 * AccreditationsApi - object-oriented interface
 * @export
 * @class AccreditationsApi
 * @extends {BaseAPI}
 */
export class AccreditationsApi extends BaseAPI {
    /**
     * 
     * @summary Delete Accreditation.
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    public apiV1AccreditationsAccreditationIdDelete(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdDeleteRequest, options?: AxiosRequestConfig) {
        return AccreditationsApiFp(this.configuration).apiV1AccreditationsAccreditationIdDelete(requestParameters.accreditationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Accreditation.
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    public apiV1AccreditationsAccreditationIdGet(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdGetRequest, options?: AxiosRequestConfig) {
        return AccreditationsApiFp(this.configuration).apiV1AccreditationsAccreditationIdGet(requestParameters.accreditationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Accreditation.
     * @param {AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    public apiV1AccreditationsAccreditationIdPut(requestParameters: AccreditationsApiApiV1AccreditationsAccreditationIdPutRequest, options?: AxiosRequestConfig) {
        return AccreditationsApiFp(this.configuration).apiV1AccreditationsAccreditationIdPut(requestParameters.accreditationId, requestParameters.updateAccreditationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Accreditations.
     * @param {AccreditationsApiApiV1AccreditationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    public apiV1AccreditationsGet(requestParameters: AccreditationsApiApiV1AccreditationsGetRequest = {}, options?: AxiosRequestConfig) {
        return AccreditationsApiFp(this.configuration).apiV1AccreditationsGet(requestParameters.name, requestParameters.logo, requestParameters.country, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Accreditation.
     * @param {AccreditationsApiApiV1AccreditationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AccreditationsApi
     */
    public apiV1AccreditationsPost(requestParameters: AccreditationsApiApiV1AccreditationsPostRequest = {}, options?: AxiosRequestConfig) {
        return AccreditationsApiFp(this.configuration).apiV1AccreditationsPost(requestParameters.createAccreditationCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
