/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { ChatUserModel } from '../models';
// @ts-ignore
import { ChatUsersModel } from '../models';
// @ts-ignore
import { CreateChatUserCommand } from '../models';
// @ts-ignore
import { LeavedGroupChannelsModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateChatUserCommand } from '../models';
/**
 * ChatUsersApi - axios parameter creator
 * @export
 */
export const ChatUsersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersCurrentGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chatusers/current`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all chatUsers.
         * @param {number} [limit] 
         * @param {string} [token] 
         * @param {string} [userIds] 
         * @param {string} [nickname] 
         * @param {string} [nicknameStartswith] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersGet: async (limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chatusers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (limit !== undefined) {
                localVarQueryParameter['Limit'] = limit;
            }

            if (token !== undefined) {
                localVarQueryParameter['Token'] = token;
            }

            if (userIds !== undefined) {
                localVarQueryParameter['UserIds'] = userIds;
            }

            if (nickname !== undefined) {
                localVarQueryParameter['Nickname'] = nickname;
            }

            if (nicknameStartswith !== undefined) {
                localVarQueryParameter['NicknameStartswith'] = nicknameStartswith;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a chatUser.
         * @param {CreateChatUserCommand} [createChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersPost: async (createChatUserCommand?: CreateChatUserCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chatusers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createChatUserCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdDelete: async (userId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('apiV1ChatusersUserIdDelete', 'userId', userId)
            const localVarPath = `/api/v1/chatusers/{userId}`
                .replace(`{${"userId"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdGet: async (userId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('apiV1ChatusersUserIdGet', 'userId', userId)
            const localVarPath = `/api/v1/chatusers/{userId}`
                .replace(`{${"userId"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Leave from group channel
         * @param {string} userId 
         * @param {string} [groupChannelUrl] 
         * @param {number} [count] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdLeavePut: async (userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('apiV1ChatusersUserIdLeavePut', 'userId', userId)
            const localVarPath = `/api/v1/chatusers/{userId}/leave`
                .replace(`{${"userId"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (groupChannelUrl !== undefined) {
                localVarQueryParameter['groupChannelUrl'] = groupChannelUrl;
            }

            if (count !== undefined) {
                localVarQueryParameter['count'] = count;
            }

            if (dryRun !== undefined) {
                localVarQueryParameter['dryRun'] = dryRun;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update chatUser.
         * @param {string} userId 
         * @param {UpdateChatUserCommand} [updateChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdPut: async (userId: string, updateChatUserCommand?: UpdateChatUserCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'userId' is not null or undefined
            assertParamExists('apiV1ChatusersUserIdPut', 'userId', userId)
            const localVarPath = `/api/v1/chatusers/{userId}`
                .replace(`{${"userId"}}`, encodeURIComponent(String(userId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateChatUserCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ChatUsersApi - functional programming interface
 * @export
 */
export const ChatUsersApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ChatUsersApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersCurrentGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersCurrentGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all chatUsers.
         * @param {number} [limit] 
         * @param {string} [token] 
         * @param {string} [userIds] 
         * @param {string} [nickname] 
         * @param {string} [nicknameStartswith] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersGet(limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUsersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersGet(limit, token, userIds, nickname, nicknameStartswith, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a chatUser.
         * @param {CreateChatUserCommand} [createChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersPost(createChatUserCommand?: CreateChatUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersPost(createChatUserCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersUserIdDelete(userId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersUserIdDelete(userId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersUserIdGet(userId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersUserIdGet(userId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Leave from group channel
         * @param {string} userId 
         * @param {string} [groupChannelUrl] 
         * @param {number} [count] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersUserIdLeavePut(userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LeavedGroupChannelsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersUserIdLeavePut(userId, groupChannelUrl, count, dryRun, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update chatUser.
         * @param {string} userId 
         * @param {UpdateChatUserCommand} [updateChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChatusersUserIdPut(userId: string, updateChatUserCommand?: UpdateChatUserCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ChatUserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChatusersUserIdPut(userId, updateChatUserCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ChatUsersApi - factory interface
 * @export
 */
export const ChatUsersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ChatUsersApiFp(configuration)
    return {
        /**
         * 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersCurrentGet(options?: any): AxiosPromise<ChatUserModel> {
            return localVarFp.apiV1ChatusersCurrentGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all chatUsers.
         * @param {number} [limit] 
         * @param {string} [token] 
         * @param {string} [userIds] 
         * @param {string} [nickname] 
         * @param {string} [nicknameStartswith] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersGet(limit?: number, token?: string, userIds?: string, nickname?: string, nicknameStartswith?: string, options?: any): AxiosPromise<ChatUsersModel> {
            return localVarFp.apiV1ChatusersGet(limit, token, userIds, nickname, nicknameStartswith, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a chatUser.
         * @param {CreateChatUserCommand} [createChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersPost(createChatUserCommand?: CreateChatUserCommand, options?: any): AxiosPromise<ChatUserModel> {
            return localVarFp.apiV1ChatusersPost(createChatUserCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdDelete(userId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ChatusersUserIdDelete(userId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get chatUser.
         * @param {string} userId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdGet(userId: string, options?: any): AxiosPromise<ChatUserModel> {
            return localVarFp.apiV1ChatusersUserIdGet(userId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Leave from group channel
         * @param {string} userId 
         * @param {string} [groupChannelUrl] 
         * @param {number} [count] 
         * @param {boolean} [dryRun] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdLeavePut(userId: string, groupChannelUrl?: string, count?: number, dryRun?: boolean, options?: any): AxiosPromise<LeavedGroupChannelsModel> {
            return localVarFp.apiV1ChatusersUserIdLeavePut(userId, groupChannelUrl, count, dryRun, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update chatUser.
         * @param {string} userId 
         * @param {UpdateChatUserCommand} [updateChatUserCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChatusersUserIdPut(userId: string, updateChatUserCommand?: UpdateChatUserCommand, options?: any): AxiosPromise<ChatUserModel> {
            return localVarFp.apiV1ChatusersUserIdPut(userId, updateChatUserCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ChatusersGet operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersGetRequest
 */
export interface ChatUsersApiApiV1ChatusersGetRequest {
    /**
     * 
     * @type {number}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly token?: string

    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly userIds?: string

    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly nickname?: string

    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersGet
     */
    readonly nicknameStartswith?: string
}

/**
 * Request parameters for apiV1ChatusersPost operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersPostRequest
 */
export interface ChatUsersApiApiV1ChatusersPostRequest {
    /**
     * 
     * @type {CreateChatUserCommand}
     * @memberof ChatUsersApiApiV1ChatusersPost
     */
    readonly createChatUserCommand?: CreateChatUserCommand
}

/**
 * Request parameters for apiV1ChatusersUserIdDelete operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdDeleteRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdDelete
     */
    readonly userId: string
}

/**
 * Request parameters for apiV1ChatusersUserIdGet operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdGetRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdGet
     */
    readonly userId: string
}

/**
 * Request parameters for apiV1ChatusersUserIdLeavePut operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdLeavePutRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdLeavePutRequest {
    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly userId: string

    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly groupChannelUrl?: string

    /**
     * 
     * @type {number}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly count?: number

    /**
     * 
     * @type {boolean}
     * @memberof ChatUsersApiApiV1ChatusersUserIdLeavePut
     */
    readonly dryRun?: boolean
}

/**
 * Request parameters for apiV1ChatusersUserIdPut operation in ChatUsersApi.
 * @export
 * @interface ChatUsersApiApiV1ChatusersUserIdPutRequest
 */
export interface ChatUsersApiApiV1ChatusersUserIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ChatUsersApiApiV1ChatusersUserIdPut
     */
    readonly userId: string

    /**
     * 
     * @type {UpdateChatUserCommand}
     * @memberof ChatUsersApiApiV1ChatusersUserIdPut
     */
    readonly updateChatUserCommand?: UpdateChatUserCommand
}

/**
 * ChatUsersApi - object-oriented interface
 * @export
 * @class ChatUsersApi
 * @extends {BaseAPI}
 */
export class ChatUsersApi extends BaseAPI {
    /**
     * 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersCurrentGet(options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersCurrentGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all chatUsers.
     * @param {ChatUsersApiApiV1ChatusersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersGet(requestParameters: ChatUsersApiApiV1ChatusersGetRequest = {}, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersGet(requestParameters.limit, requestParameters.token, requestParameters.userIds, requestParameters.nickname, requestParameters.nicknameStartswith, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a chatUser.
     * @param {ChatUsersApiApiV1ChatusersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersPost(requestParameters: ChatUsersApiApiV1ChatusersPostRequest = {}, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersPost(requestParameters.createChatUserCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete chatUser.
     * @param {ChatUsersApiApiV1ChatusersUserIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersUserIdDelete(requestParameters: ChatUsersApiApiV1ChatusersUserIdDeleteRequest, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersUserIdDelete(requestParameters.userId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get chatUser.
     * @param {ChatUsersApiApiV1ChatusersUserIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersUserIdGet(requestParameters: ChatUsersApiApiV1ChatusersUserIdGetRequest, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersUserIdGet(requestParameters.userId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Leave from group channel
     * @param {ChatUsersApiApiV1ChatusersUserIdLeavePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersUserIdLeavePut(requestParameters: ChatUsersApiApiV1ChatusersUserIdLeavePutRequest, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersUserIdLeavePut(requestParameters.userId, requestParameters.groupChannelUrl, requestParameters.count, requestParameters.dryRun, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update chatUser.
     * @param {ChatUsersApiApiV1ChatusersUserIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ChatUsersApi
     */
    public apiV1ChatusersUserIdPut(requestParameters: ChatUsersApiApiV1ChatusersUserIdPutRequest, options?: AxiosRequestConfig) {
        return ChatUsersApiFp(this.configuration).apiV1ChatusersUserIdPut(requestParameters.userId, requestParameters.updateChatUserCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
