/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CHManagerModel } from '../models';
// @ts-ignore
import { CHManagersModel } from '../models';
// @ts-ignore
import { CreateCHManagerCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateCHManagerCommand } from '../models';
/**
 * CHManagersApi - axios parameter creator
 * @export
 */
export const CHManagersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete CHManager.
         * @param {string} cHManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdDelete: async (cHManagerId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHManagerId' is not null or undefined
            assertParamExists('apiV1ChmanagersCHManagerIdDelete', 'cHManagerId', cHManagerId)
            const localVarPath = `/api/v1/chmanagers/{cHManagerId}`
                .replace(`{${"cHManagerId"}}`, encodeURIComponent(String(cHManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get CHManager.
         * @param {string} cHManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdGet: async (cHManagerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHManagerId' is not null or undefined
            assertParamExists('apiV1ChmanagersCHManagerIdGet', 'cHManagerId', cHManagerId)
            const localVarPath = `/api/v1/chmanagers/{cHManagerId}`
                .replace(`{${"cHManagerId"}}`, encodeURIComponent(String(cHManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update CHManager.
         * @param {string} cHManagerId 
         * @param {UpdateCHManagerCommand} [updateCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdPut: async (cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'cHManagerId' is not null or undefined
            assertParamExists('apiV1ChmanagersCHManagerIdPut', 'cHManagerId', cHManagerId)
            const localVarPath = `/api/v1/chmanagers/{cHManagerId}`
                .replace(`{${"cHManagerId"}}`, encodeURIComponent(String(cHManagerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateCHManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all CHManagers.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersGet: async (id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a CHManager.
         * @param {CreateCHManagerCommand} [createCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersPost: async (createCHManagerCommand?: CreateCHManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/chmanagers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createCHManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CHManagersApi - functional programming interface
 * @export
 */
export const CHManagersApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CHManagersApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete CHManager.
         * @param {string} cHManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChmanagersCHManagerIdDelete(cHManagerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChmanagersCHManagerIdDelete(cHManagerId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get CHManager.
         * @param {string} cHManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChmanagersCHManagerIdGet(cHManagerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChmanagersCHManagerIdGet(cHManagerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update CHManager.
         * @param {string} cHManagerId 
         * @param {UpdateCHManagerCommand} [updateCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChmanagersCHManagerIdPut(cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChmanagersCHManagerIdPut(cHManagerId, updateCHManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all CHManagers.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a CHManager.
         * @param {CreateCHManagerCommand} [createCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ChmanagersPost(createCHManagerCommand?: CreateCHManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CHManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ChmanagersPost(createCHManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CHManagersApi - factory interface
 * @export
 */
export const CHManagersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CHManagersApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete CHManager.
         * @param {string} cHManagerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdDelete(cHManagerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ChmanagersCHManagerIdDelete(cHManagerId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get CHManager.
         * @param {string} cHManagerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdGet(cHManagerId: string, options?: any): AxiosPromise<CHManagerModel> {
            return localVarFp.apiV1ChmanagersCHManagerIdGet(cHManagerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update CHManager.
         * @param {string} cHManagerId 
         * @param {UpdateCHManagerCommand} [updateCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersCHManagerIdPut(cHManagerId: string, updateCHManagerCommand?: UpdateCHManagerCommand, options?: any): AxiosPromise<CHManagerModel> {
            return localVarFp.apiV1ChmanagersCHManagerIdPut(cHManagerId, updateCHManagerCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all CHManagers.
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersGet(id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CHManagersModel> {
            return localVarFp.apiV1ChmanagersGet(id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a CHManager.
         * @param {CreateCHManagerCommand} [createCHManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ChmanagersPost(createCHManagerCommand?: CreateCHManagerCommand, options?: any): AxiosPromise<CHManagerModel> {
            return localVarFp.apiV1ChmanagersPost(createCHManagerCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ChmanagersCHManagerIdDelete operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdDelete
     */
    readonly cHManagerId: string

    /**
     * 
     * @type {boolean}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ChmanagersCHManagerIdGet operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdGetRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdGet
     */
    readonly cHManagerId: string
}

/**
 * Request parameters for apiV1ChmanagersCHManagerIdPut operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersCHManagerIdPutRequest
 */
export interface CHManagersApiApiV1ChmanagersCHManagerIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdPut
     */
    readonly cHManagerId: string

    /**
     * 
     * @type {UpdateCHManagerCommand}
     * @memberof CHManagersApiApiV1ChmanagersCHManagerIdPut
     */
    readonly updateCHManagerCommand?: UpdateCHManagerCommand
}

/**
 * Request parameters for apiV1ChmanagersGet operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersGetRequest
 */
export interface CHManagersApiApiV1ChmanagersGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CHManagersApiApiV1ChmanagersGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ChmanagersPost operation in CHManagersApi.
 * @export
 * @interface CHManagersApiApiV1ChmanagersPostRequest
 */
export interface CHManagersApiApiV1ChmanagersPostRequest {
    /**
     * 
     * @type {CreateCHManagerCommand}
     * @memberof CHManagersApiApiV1ChmanagersPost
     */
    readonly createCHManagerCommand?: CreateCHManagerCommand
}

/**
 * CHManagersApi - object-oriented interface
 * @export
 * @class CHManagersApi
 * @extends {BaseAPI}
 */
export class CHManagersApi extends BaseAPI {
    /**
     * 
     * @summary Delete CHManager.
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    public apiV1ChmanagersCHManagerIdDelete(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdDeleteRequest, options?: AxiosRequestConfig) {
        return CHManagersApiFp(this.configuration).apiV1ChmanagersCHManagerIdDelete(requestParameters.cHManagerId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get CHManager.
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    public apiV1ChmanagersCHManagerIdGet(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdGetRequest, options?: AxiosRequestConfig) {
        return CHManagersApiFp(this.configuration).apiV1ChmanagersCHManagerIdGet(requestParameters.cHManagerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update CHManager.
     * @param {CHManagersApiApiV1ChmanagersCHManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    public apiV1ChmanagersCHManagerIdPut(requestParameters: CHManagersApiApiV1ChmanagersCHManagerIdPutRequest, options?: AxiosRequestConfig) {
        return CHManagersApiFp(this.configuration).apiV1ChmanagersCHManagerIdPut(requestParameters.cHManagerId, requestParameters.updateCHManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all CHManagers.
     * @param {CHManagersApiApiV1ChmanagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    public apiV1ChmanagersGet(requestParameters: CHManagersApiApiV1ChmanagersGetRequest = {}, options?: AxiosRequestConfig) {
        return CHManagersApiFp(this.configuration).apiV1ChmanagersGet(requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a CHManager.
     * @param {CHManagersApiApiV1ChmanagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CHManagersApi
     */
    public apiV1ChmanagersPost(requestParameters: CHManagersApiApiV1ChmanagersPostRequest = {}, options?: AxiosRequestConfig) {
        return CHManagersApiFp(this.configuration).apiV1ChmanagersPost(requestParameters.createCHManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
