/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateCurationCommand } from '../models';
// @ts-ignore
import { CurationModel } from '../models';
// @ts-ignore
import { CurationsModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { TranslateCurationCommand } from '../models';
// @ts-ignore
import { UpdateCurationCommand } from '../models';
/**
 * CurationsApi - axios parameter creator
 * @export
 */
export const CurationsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete CurationItem
         * @param {string} curationId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdDelete: async (curationId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdDelete', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Curation by id
         * @param {string} curationId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdGet: async (curationId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdGet', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Curation.
         * @param {string} curationId 
         * @param {UpdateCurationCommand} [updateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdPut: async (curationId: string, updateCurationCommand?: UpdateCurationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdPut', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateCurationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate Curation.
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdReactivatePut: async (curationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdReactivatePut', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}/reactivate`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate CurationItem
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdRevalidatePost: async (curationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdRevalidatePost', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}/revalidate`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate curation
         * @param {string} curationId 
         * @param {TranslateCurationCommand} [translateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdTranslatePost: async (curationId: string, translateCurationCommand?: TranslateCurationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'curationId' is not null or undefined
            assertParamExists('apiV1CurationsCurationIdTranslatePost', 'curationId', curationId)
            const localVarPath = `/api/v1/curations/{curationId}/translate`
                .replace(`{${"curationId"}}`, encodeURIComponent(String(curationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateCurationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Curations
         * @param {string} countryId 
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {string} [serarchTerm] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsGet: async (countryId: string, specialtyTypeId: string, languageCode?: string, serarchTerm?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'countryId' is not null or undefined
            assertParamExists('apiV1CurationsGet', 'countryId', countryId)
            // verify required parameter 'specialtyTypeId' is not null or undefined
            assertParamExists('apiV1CurationsGet', 'specialtyTypeId', specialtyTypeId)
            const localVarPath = `/api/v1/curations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (countryId !== undefined) {
                localVarQueryParameter['CountryId'] = countryId;
            }

            if (specialtyTypeId !== undefined) {
                localVarQueryParameter['SpecialtyTypeId'] = specialtyTypeId;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (serarchTerm !== undefined) {
                localVarQueryParameter['SerarchTerm'] = serarchTerm;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Curation.
         * @param {CreateCurationCommand} [createCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsPost: async (createCurationCommand?: CreateCurationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/curations`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createCurationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CurationsApi - functional programming interface
 * @export
 */
export const CurationsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CurationsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete CurationItem
         * @param {string} curationId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdDelete(curationId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdDelete(curationId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Curation by id
         * @param {string} curationId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdGet(curationId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdGet(curationId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Curation.
         * @param {string} curationId 
         * @param {UpdateCurationCommand} [updateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdPut(curationId: string, updateCurationCommand?: UpdateCurationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdPut(curationId, updateCurationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate Curation.
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdReactivatePut(curationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdReactivatePut(curationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate CurationItem
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdRevalidatePost(curationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdRevalidatePost(curationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate curation
         * @param {string} curationId 
         * @param {TranslateCurationCommand} [translateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsCurationIdTranslatePost(curationId: string, translateCurationCommand?: TranslateCurationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsCurationIdTranslatePost(curationId, translateCurationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Curations
         * @param {string} countryId 
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {string} [serarchTerm] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsGet(countryId: string, specialtyTypeId: string, languageCode?: string, serarchTerm?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsGet(countryId, specialtyTypeId, languageCode, serarchTerm, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Curation.
         * @param {CreateCurationCommand} [createCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CurationsPost(createCurationCommand?: CreateCurationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CurationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CurationsPost(createCurationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CurationsApi - factory interface
 * @export
 */
export const CurationsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CurationsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete CurationItem
         * @param {string} curationId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdDelete(curationId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurationsCurationIdDelete(curationId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Curation by id
         * @param {string} curationId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdGet(curationId: string, languageCode?: string, options?: any): AxiosPromise<CurationModel> {
            return localVarFp.apiV1CurationsCurationIdGet(curationId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Curation.
         * @param {string} curationId 
         * @param {UpdateCurationCommand} [updateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdPut(curationId: string, updateCurationCommand?: UpdateCurationCommand, options?: any): AxiosPromise<CurationModel> {
            return localVarFp.apiV1CurationsCurationIdPut(curationId, updateCurationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate Curation.
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdReactivatePut(curationId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurationsCurationIdReactivatePut(curationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate CurationItem
         * @param {string} curationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdRevalidatePost(curationId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurationsCurationIdRevalidatePost(curationId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate curation
         * @param {string} curationId 
         * @param {TranslateCurationCommand} [translateCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsCurationIdTranslatePost(curationId: string, translateCurationCommand?: TranslateCurationCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1CurationsCurationIdTranslatePost(curationId, translateCurationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Curations
         * @param {string} countryId 
         * @param {string} specialtyTypeId 
         * @param {string} [languageCode] 
         * @param {string} [serarchTerm] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsGet(countryId: string, specialtyTypeId: string, languageCode?: string, serarchTerm?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CurationsModel> {
            return localVarFp.apiV1CurationsGet(countryId, specialtyTypeId, languageCode, serarchTerm, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Curation.
         * @param {CreateCurationCommand} [createCurationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CurationsPost(createCurationCommand?: CreateCurationCommand, options?: any): AxiosPromise<CurationModel> {
            return localVarFp.apiV1CurationsPost(createCurationCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1CurationsCurationIdDelete operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdDeleteRequest
 */
export interface CurationsApiApiV1CurationsCurationIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdDelete
     */
    readonly curationId: string

    /**
     * 
     * @type {boolean}
     * @memberof CurationsApiApiV1CurationsCurationIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1CurationsCurationIdGet operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdGetRequest
 */
export interface CurationsApiApiV1CurationsCurationIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdGet
     */
    readonly curationId: string

    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1CurationsCurationIdPut operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdPutRequest
 */
export interface CurationsApiApiV1CurationsCurationIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdPut
     */
    readonly curationId: string

    /**
     * 
     * @type {UpdateCurationCommand}
     * @memberof CurationsApiApiV1CurationsCurationIdPut
     */
    readonly updateCurationCommand?: UpdateCurationCommand
}

/**
 * Request parameters for apiV1CurationsCurationIdReactivatePut operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdReactivatePutRequest
 */
export interface CurationsApiApiV1CurationsCurationIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdReactivatePut
     */
    readonly curationId: string
}

/**
 * Request parameters for apiV1CurationsCurationIdRevalidatePost operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdRevalidatePostRequest
 */
export interface CurationsApiApiV1CurationsCurationIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdRevalidatePost
     */
    readonly curationId: string
}

/**
 * Request parameters for apiV1CurationsCurationIdTranslatePost operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsCurationIdTranslatePostRequest
 */
export interface CurationsApiApiV1CurationsCurationIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsCurationIdTranslatePost
     */
    readonly curationId: string

    /**
     * 
     * @type {TranslateCurationCommand}
     * @memberof CurationsApiApiV1CurationsCurationIdTranslatePost
     */
    readonly translateCurationCommand?: TranslateCurationCommand
}

/**
 * Request parameters for apiV1CurationsGet operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsGetRequest
 */
export interface CurationsApiApiV1CurationsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly countryId: string

    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly specialtyTypeId: string

    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly serarchTerm?: string

    /**
     * 
     * @type {boolean}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CurationsApiApiV1CurationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1CurationsPost operation in CurationsApi.
 * @export
 * @interface CurationsApiApiV1CurationsPostRequest
 */
export interface CurationsApiApiV1CurationsPostRequest {
    /**
     * 
     * @type {CreateCurationCommand}
     * @memberof CurationsApiApiV1CurationsPost
     */
    readonly createCurationCommand?: CreateCurationCommand
}

/**
 * CurationsApi - object-oriented interface
 * @export
 * @class CurationsApi
 * @extends {BaseAPI}
 */
export class CurationsApi extends BaseAPI {
    /**
     * 
     * @summary Delete CurationItem
     * @param {CurationsApiApiV1CurationsCurationIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdDelete(requestParameters: CurationsApiApiV1CurationsCurationIdDeleteRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdDelete(requestParameters.curationId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Curation by id
     * @param {CurationsApiApiV1CurationsCurationIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdGet(requestParameters: CurationsApiApiV1CurationsCurationIdGetRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdGet(requestParameters.curationId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Curation.
     * @param {CurationsApiApiV1CurationsCurationIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdPut(requestParameters: CurationsApiApiV1CurationsCurationIdPutRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdPut(requestParameters.curationId, requestParameters.updateCurationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate Curation.
     * @param {CurationsApiApiV1CurationsCurationIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdReactivatePut(requestParameters: CurationsApiApiV1CurationsCurationIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdReactivatePut(requestParameters.curationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate CurationItem
     * @param {CurationsApiApiV1CurationsCurationIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdRevalidatePost(requestParameters: CurationsApiApiV1CurationsCurationIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdRevalidatePost(requestParameters.curationId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate curation
     * @param {CurationsApiApiV1CurationsCurationIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsCurationIdTranslatePost(requestParameters: CurationsApiApiV1CurationsCurationIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsCurationIdTranslatePost(requestParameters.curationId, requestParameters.translateCurationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Curations
     * @param {CurationsApiApiV1CurationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsGet(requestParameters: CurationsApiApiV1CurationsGetRequest, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsGet(requestParameters.countryId, requestParameters.specialtyTypeId, requestParameters.languageCode, requestParameters.serarchTerm, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Curation.
     * @param {CurationsApiApiV1CurationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CurationsApi
     */
    public apiV1CurationsPost(requestParameters: CurationsApiApiV1CurationsPostRequest = {}, options?: AxiosRequestConfig) {
        return CurationsApiFp(this.configuration).apiV1CurationsPost(requestParameters.createCurationCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
