/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateFaqCategoryCommand } from '../models';
// @ts-ignore
import { FaqCategoriesModel } from '../models';
// @ts-ignore
import { FaqCategoryModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateFaqCategoryCommand } from '../models';
/**
 * FaqCategoriesApi - axios parameter creator
 * @export
 */
export const FaqCategoriesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete FaqCategory.
         * @param {string} faqCategoryId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdDelete: async (faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqCategoryId' is not null or undefined
            assertParamExists('apiV1FaqcategoriesFaqCategoryIdDelete', 'faqCategoryId', faqCategoryId)
            const localVarPath = `/api/v1/faqcategories/{faqCategoryId}`
                .replace(`{${"faqCategoryId"}}`, encodeURIComponent(String(faqCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (forceDelete !== undefined) {
                localVarQueryParameter['forceDelete'] = forceDelete;
            }

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get FaqCategory.
         * @param {string} faqCategoryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdGet: async (faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqCategoryId' is not null or undefined
            assertParamExists('apiV1FaqcategoriesFaqCategoryIdGet', 'faqCategoryId', faqCategoryId)
            const localVarPath = `/api/v1/faqcategories/{faqCategoryId}`
                .replace(`{${"faqCategoryId"}}`, encodeURIComponent(String(faqCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update FaqCategory.
         * @param {string} faqCategoryId 
         * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdPut: async (faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqCategoryId' is not null or undefined
            assertParamExists('apiV1FaqcategoriesFaqCategoryIdPut', 'faqCategoryId', faqCategoryId)
            const localVarPath = `/api/v1/faqcategories/{faqCategoryId}`
                .replace(`{${"faqCategoryId"}}`, encodeURIComponent(String(faqCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateFaqCategoryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate faqCategory
         * @param {string} faqCategoryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdRevalidatePost: async (faqCategoryId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqCategoryId' is not null or undefined
            assertParamExists('apiV1FaqcategoriesFaqCategoryIdRevalidatePost', 'faqCategoryId', faqCategoryId)
            const localVarPath = `/api/v1/faqcategories/{faqCategoryId}/revalidate`
                .replace(`{${"faqCategoryId"}}`, encodeURIComponent(String(faqCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all FaqCategories.
         * @param {string} [id] 
         * @param {string} [parentId] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesGet: async (id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/faqcategories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (parentId !== undefined) {
                localVarQueryParameter['ParentId'] = parentId;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a FaqCategory.
         * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesPost: async (createFaqCategoryCommand?: CreateFaqCategoryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/faqcategories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createFaqCategoryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get FaqCategory by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesSlugGet: async (slug: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1FaqcategoriesSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/faqcategories/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FaqCategoriesApi - functional programming interface
 * @export
 */
export const FaqCategoriesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = FaqCategoriesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete FaqCategory.
         * @param {string} faqCategoryId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId, forceDelete, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get FaqCategory.
         * @param {string} faqCategoryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update FaqCategory.
         * @param {string} faqCategoryId 
         * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId, updateFaqCategoryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate faqCategory
         * @param {string} faqCategoryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all FaqCategories.
         * @param {string} [id] 
         * @param {string} [parentId] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesGet(id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoriesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesGet(id, parentId, name, hospitalId, hospitalName, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a FaqCategory.
         * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesPost(createFaqCategoryCommand?: CreateFaqCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesPost(createFaqCategoryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get FaqCategory by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqcategoriesSlugGet(slug: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqcategoriesSlugGet(slug, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * FaqCategoriesApi - factory interface
 * @export
 */
export const FaqCategoriesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = FaqCategoriesApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete FaqCategory.
         * @param {string} faqCategoryId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId: string, forceDelete?: boolean, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqcategoriesFaqCategoryIdDelete(faqCategoryId, forceDelete, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get FaqCategory.
         * @param {string} faqCategoryId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<FaqCategoryModel> {
            return localVarFp.apiV1FaqcategoriesFaqCategoryIdGet(faqCategoryId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update FaqCategory.
         * @param {string} faqCategoryId 
         * @param {UpdateFaqCategoryCommand} [updateFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId: string, updateFaqCategoryCommand?: UpdateFaqCategoryCommand, options?: any): AxiosPromise<FaqCategoryModel> {
            return localVarFp.apiV1FaqcategoriesFaqCategoryIdPut(faqCategoryId, updateFaqCategoryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate faqCategory
         * @param {string} faqCategoryId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqcategoriesFaqCategoryIdRevalidatePost(faqCategoryId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all FaqCategories.
         * @param {string} [id] 
         * @param {string} [parentId] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesGet(id?: string, parentId?: string, name?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqCategoriesModel> {
            return localVarFp.apiV1FaqcategoriesGet(id, parentId, name, hospitalId, hospitalName, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a FaqCategory.
         * @param {CreateFaqCategoryCommand} [createFaqCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesPost(createFaqCategoryCommand?: CreateFaqCategoryCommand, options?: any): AxiosPromise<FaqCategoryModel> {
            return localVarFp.apiV1FaqcategoriesPost(createFaqCategoryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get FaqCategory by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqcategoriesSlugGet(slug: string, languageCode?: string, options?: any): AxiosPromise<FaqCategoryModel> {
            return localVarFp.apiV1FaqcategoriesSlugGet(slug, languageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdDelete operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly faqCategoryId: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly forceDelete?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly faqCategoryId: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdPut operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPut
     */
    readonly faqCategoryId: string

    /**
     * 
     * @type {UpdateFaqCategoryCommand}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPut
     */
    readonly updateFaqCategoryCommand?: UpdateFaqCategoryCommand
}

/**
 * Request parameters for apiV1FaqcategoriesFaqCategoryIdRevalidatePost operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePost
     */
    readonly faqCategoryId: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1FaqcategoriesGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly parentId?: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FaqcategoriesPost operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesPostRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesPostRequest {
    /**
     * 
     * @type {CreateFaqCategoryCommand}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesPost
     */
    readonly createFaqCategoryCommand?: CreateFaqCategoryCommand
}

/**
 * Request parameters for apiV1FaqcategoriesSlugGet operation in FaqCategoriesApi.
 * @export
 * @interface FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest
 */
export interface FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof FaqCategoriesApiApiV1FaqcategoriesSlugGet
     */
    readonly languageCode?: string
}

/**
 * FaqCategoriesApi - object-oriented interface
 * @export
 * @class FaqCategoriesApi
 * @extends {BaseAPI}
 */
export class FaqCategoriesApi extends BaseAPI {
    /**
     * 
     * @summary Delete FaqCategory.
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesFaqCategoryIdDelete(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdDeleteRequest, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesFaqCategoryIdDelete(requestParameters.faqCategoryId, requestParameters.forceDelete, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get FaqCategory.
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesFaqCategoryIdGet(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdGetRequest, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesFaqCategoryIdGet(requestParameters.faqCategoryId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update FaqCategory.
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesFaqCategoryIdPut(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdPutRequest, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesFaqCategoryIdPut(requestParameters.faqCategoryId, requestParameters.updateFaqCategoryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate faqCategory
     * @param {FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesFaqCategoryIdRevalidatePost(requestParameters: FaqCategoriesApiApiV1FaqcategoriesFaqCategoryIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesFaqCategoryIdRevalidatePost(requestParameters.faqCategoryId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all FaqCategories.
     * @param {FaqCategoriesApiApiV1FaqcategoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesGet(requestParameters: FaqCategoriesApiApiV1FaqcategoriesGetRequest = {}, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesGet(requestParameters.id, requestParameters.parentId, requestParameters.name, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a FaqCategory.
     * @param {FaqCategoriesApiApiV1FaqcategoriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesPost(requestParameters: FaqCategoriesApiApiV1FaqcategoriesPostRequest = {}, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesPost(requestParameters.createFaqCategoryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get FaqCategory by slug.
     * @param {FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqCategoriesApi
     */
    public apiV1FaqcategoriesSlugGet(requestParameters: FaqCategoriesApiApiV1FaqcategoriesSlugGetRequest, options?: AxiosRequestConfig) {
        return FaqCategoriesApiFp(this.configuration).apiV1FaqcategoriesSlugGet(requestParameters.slug, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }
}
