/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateWebAppCommand } from '../models';
// @ts-ignore
import { DeployStatus } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateWebAppCommand } from '../models';
// @ts-ignore
import { WebAppEnvironmentsModel } from '../models';
// @ts-ignore
import { WebAppModel } from '../models';
// @ts-ignore
import { WebAppsModel } from '../models';
/**
 * WebAppsApi - axios parameter creator
 * @export
 */
export const WebAppsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Upload favicon
         * @param {string} [id] 
         * @param {File} [formFile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsFaviconPost: async (id?: string, formFile?: File, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/webapps/favicon`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new ((configuration && configuration.formDataCtor) || FormData)();

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


            if (id !== undefined) { 
                localVarFormParams.append('Id', id as any);
            }
    
            if (formFile !== undefined) { 
                localVarFormParams.append('FormFile', formFile as any);
            }
    
    
            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrive all WebApp configuration
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [appName] 
         * @param {string} [hostName] 
         * @param {DeployStatus} [deployStatus] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsGet: async (id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/webapps`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (appName !== undefined) {
                localVarQueryParameter['AppName'] = appName;
            }

            if (hostName !== undefined) {
                localVarQueryParameter['HostName'] = hostName;
            }

            if (deployStatus !== undefined) {
                localVarQueryParameter['DeployStatus'] = deployStatus;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete WebApp configuration soft or permanent
         * @param {string} id 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdDelete: async (id: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1WebappsIdDelete', 'id', id)
            const localVarPath = `/api/v1/webapps/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary GET Webapp Environment Variables
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdEnvironmentvariablesGet: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1WebappsIdEnvironmentvariablesGet', 'id', id)
            const localVarPath = `/api/v1/webapps/{id}/environmentvariables`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retrive WebApp configuration
         * @param {string} id 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdGet: async (id: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1WebappsIdGet', 'id', id)
            const localVarPath = `/api/v1/webapps/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update WebApp configuration
         * @param {string} id 
         * @param {UpdateWebAppCommand} [updateWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdPut: async (id: string, updateWebAppCommand?: UpdateWebAppCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1WebappsIdPut', 'id', id)
            const localVarPath = `/api/v1/webapps/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateWebAppCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate WebApp
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdReactivatePut: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('apiV1WebappsIdReactivatePut', 'id', id)
            const localVarPath = `/api/v1/webapps/{id}/reactivate`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create WebApp configuration
         * @param {CreateWebAppCommand} [createWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsPost: async (createWebAppCommand?: CreateWebAppCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/webapps`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createWebAppCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * WebAppsApi - functional programming interface
 * @export
 */
export const WebAppsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = WebAppsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Upload favicon
         * @param {string} [id] 
         * @param {File} [formFile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsFaviconPost(id?: string, formFile?: File, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsFaviconPost(id, formFile, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Retrive all WebApp configuration
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [appName] 
         * @param {string} [hostName] 
         * @param {DeployStatus} [deployStatus] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsGet(id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsGet(id, hospitalId, hospitalName, appName, hostName, deployStatus, languageCode, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete WebApp configuration soft or permanent
         * @param {string} id 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsIdDelete(id: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsIdDelete(id, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary GET Webapp Environment Variables
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsIdEnvironmentvariablesGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppEnvironmentsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsIdEnvironmentvariablesGet(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Retrive WebApp configuration
         * @param {string} id 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsIdGet(id: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsIdGet(id, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update WebApp configuration
         * @param {string} id 
         * @param {UpdateWebAppCommand} [updateWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsIdPut(id: string, updateWebAppCommand?: UpdateWebAppCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsIdPut(id, updateWebAppCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate WebApp
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsIdReactivatePut(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsIdReactivatePut(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create WebApp configuration
         * @param {CreateWebAppCommand} [createWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1WebappsPost(createWebAppCommand?: CreateWebAppCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1WebappsPost(createWebAppCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * WebAppsApi - factory interface
 * @export
 */
export const WebAppsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = WebAppsApiFp(configuration)
    return {
        /**
         * 
         * @summary Upload favicon
         * @param {string} [id] 
         * @param {File} [formFile] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsFaviconPost(id?: string, formFile?: File, options?: any): AxiosPromise<Array<string>> {
            return localVarFp.apiV1WebappsFaviconPost(id, formFile, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrive all WebApp configuration
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [appName] 
         * @param {string} [hostName] 
         * @param {DeployStatus} [deployStatus] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsGet(id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<WebAppsModel> {
            return localVarFp.apiV1WebappsGet(id, hospitalId, hospitalName, appName, hostName, deployStatus, languageCode, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete WebApp configuration soft or permanent
         * @param {string} id 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdDelete(id: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1WebappsIdDelete(id, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary GET Webapp Environment Variables
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdEnvironmentvariablesGet(id: string, options?: any): AxiosPromise<WebAppEnvironmentsModel> {
            return localVarFp.apiV1WebappsIdEnvironmentvariablesGet(id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retrive WebApp configuration
         * @param {string} id 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdGet(id: string, languageCode?: string, options?: any): AxiosPromise<WebAppModel> {
            return localVarFp.apiV1WebappsIdGet(id, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update WebApp configuration
         * @param {string} id 
         * @param {UpdateWebAppCommand} [updateWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdPut(id: string, updateWebAppCommand?: UpdateWebAppCommand, options?: any): AxiosPromise<WebAppModel> {
            return localVarFp.apiV1WebappsIdPut(id, updateWebAppCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate WebApp
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsIdReactivatePut(id: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1WebappsIdReactivatePut(id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create WebApp configuration
         * @param {CreateWebAppCommand} [createWebAppCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1WebappsPost(createWebAppCommand?: CreateWebAppCommand, options?: any): AxiosPromise<WebAppModel> {
            return localVarFp.apiV1WebappsPost(createWebAppCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1WebappsFaviconPost operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsFaviconPostRequest
 */
export interface WebAppsApiApiV1WebappsFaviconPostRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsFaviconPost
     */
    readonly id?: string

    /**
     * 
     * @type {File}
     * @memberof WebAppsApiApiV1WebappsFaviconPost
     */
    readonly formFile?: File
}

/**
 * Request parameters for apiV1WebappsGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsGetRequest
 */
export interface WebAppsApiApiV1WebappsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly appName?: string

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hostName?: string

    /**
     * 
     * @type {DeployStatus}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly deployStatus?: DeployStatus

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1WebappsIdDelete operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdDeleteRequest
 */
export interface WebAppsApiApiV1WebappsIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdDelete
     */
    readonly id: string

    /**
     * 
     * @type {boolean}
     * @memberof WebAppsApiApiV1WebappsIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1WebappsIdEnvironmentvariablesGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest
 */
export interface WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdEnvironmentvariablesGet
     */
    readonly id: string
}

/**
 * Request parameters for apiV1WebappsIdGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdGetRequest
 */
export interface WebAppsApiApiV1WebappsIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdGet
     */
    readonly id: string

    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1WebappsIdPut operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdPutRequest
 */
export interface WebAppsApiApiV1WebappsIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdPut
     */
    readonly id: string

    /**
     * 
     * @type {UpdateWebAppCommand}
     * @memberof WebAppsApiApiV1WebappsIdPut
     */
    readonly updateWebAppCommand?: UpdateWebAppCommand
}

/**
 * Request parameters for apiV1WebappsIdReactivatePut operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdReactivatePutRequest
 */
export interface WebAppsApiApiV1WebappsIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdReactivatePut
     */
    readonly id: string
}

/**
 * Request parameters for apiV1WebappsPost operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsPostRequest
 */
export interface WebAppsApiApiV1WebappsPostRequest {
    /**
     * 
     * @type {CreateWebAppCommand}
     * @memberof WebAppsApiApiV1WebappsPost
     */
    readonly createWebAppCommand?: CreateWebAppCommand
}

/**
 * WebAppsApi - object-oriented interface
 * @export
 * @class WebAppsApi
 * @extends {BaseAPI}
 */
export class WebAppsApi extends BaseAPI {
    /**
     * 
     * @summary Upload favicon
     * @param {WebAppsApiApiV1WebappsFaviconPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsFaviconPost(requestParameters: WebAppsApiApiV1WebappsFaviconPostRequest = {}, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsFaviconPost(requestParameters.id, requestParameters.formFile, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrive all WebApp configuration
     * @param {WebAppsApiApiV1WebappsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsGet(requestParameters: WebAppsApiApiV1WebappsGetRequest = {}, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsGet(requestParameters.id, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.appName, requestParameters.hostName, requestParameters.deployStatus, requestParameters.languageCode, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete WebApp configuration soft or permanent
     * @param {WebAppsApiApiV1WebappsIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsIdDelete(requestParameters: WebAppsApiApiV1WebappsIdDeleteRequest, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsIdDelete(requestParameters.id, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary GET Webapp Environment Variables
     * @param {WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsIdEnvironmentvariablesGet(requestParameters: WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsIdEnvironmentvariablesGet(requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retrive WebApp configuration
     * @param {WebAppsApiApiV1WebappsIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsIdGet(requestParameters: WebAppsApiApiV1WebappsIdGetRequest, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsIdGet(requestParameters.id, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update WebApp configuration
     * @param {WebAppsApiApiV1WebappsIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsIdPut(requestParameters: WebAppsApiApiV1WebappsIdPutRequest, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsIdPut(requestParameters.id, requestParameters.updateWebAppCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate WebApp
     * @param {WebAppsApiApiV1WebappsIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsIdReactivatePut(requestParameters: WebAppsApiApiV1WebappsIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsIdReactivatePut(requestParameters.id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create WebApp configuration
     * @param {WebAppsApiApiV1WebappsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    public apiV1WebappsPost(requestParameters: WebAppsApiApiV1WebappsPostRequest = {}, options?: AxiosRequestConfig) {
        return WebAppsApiFp(this.configuration).apiV1WebappsPost(requestParameters.createWebAppCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
